--[[
if RBH_IntelFrame == nil then
   CreateFrame("Frame", "RBH_IntelFrame",UIParent);
   RBH_IntelFrame:SetScript("OnEvent", function() RBH_IntelOnEvent(event) end);    
   RBH_IntelFrame:RegisterEvent("WHO_LIST_UPDATE");   
end

function RBH_IntelOnEvent(event)
   if event == "WHO_LIST_UPDATE" then        
      local i,j
      local n = GetNumWhoResults()      
      local pname,prealm = UnitName("player")
      local name, guild, level, race, class, zone
      RBH_BountySpyCounter = RBH_BountySpyCounter + 1
      if n == 0 then
         RBH_LargessMessage(RBH_BountySpyNames[RBH_BountySpyCounter].name.." could not be found.")
      end
      for i = 1,n do
         name,guild,level,race,class,zone = GetWhoInfo(i)         
         RBH_LargessMessage("Found: "..name.." <"..guild.."> "..tostring(level).." "..race.." "..class.." "..zone)
         for j = 1, #RBH_IntelList do
            if RBH_IntelList[j].name == name then
               RBH_IntelList[j].level = tostring(level)
               RBH_IntelList[j].race = race
               RBH_IntelList[j].class = class
               RBH_IntelList[j].zone = zone
               RBH_IntelList[j].realm = prealm
               RBH_IntelList[j].intelage = time()
            end
         end
      end
      if RBH_BountySpyCounter >= RBH_BountySpyCnt then
         RBH_LargessMessage("All guild agents have reported in.")
         FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
      end
   end
end ]]--

function RBH_IntelPost()
   local i
   RBH_IntelList = {}
   for i = 1,#RBH_HitList do
      RBH_IntelList[i] = {}
      RBH_IntelList[i].id = RBH_HitList[i].id
      RBH_IntelList[i].faction = RBH_HitList[i].faction
      RBH_IntelList[i].realm = RBH_HitList[i].realm
      RBH_IntelList[i].name = RBH_HitList[i].name
      RBH_IntelList[i].state = RBH_HitList[i].state
      if RBH_HitList[i].intelage == nil or RBH_HitList[i].intelage == "" then
         RBH_HitList[i].intelage = 0
      end
      RBH_IntelList[i].intelage = RBH_HitList[i].intelage
   end
   RBH_LargessMessage("Requests for bounty intelligence have been posted.")
end

function RBH_IntelSpy()
   local i     
   RBH_BountySpyCnt = 0  
   RBH_BountySpyNames = {}
   RBH_BountySpyCounter = 0   
   for i = 1,#RBH_IntelList do
      if RBH_IntelList[i].faction == select(1,UnitFactionGroup("player")) and (GetRealmName() == RBH_IntelList[i].realm or RBH_IntelList[i].realm == nil or RBH_IntelList[i].realm == "") then           
         RBH_ActionQueueAdd([[RBH_SendWhoQuery(RBH_IntelList[]]..i..[[].name)]] , 5*(i-1))         
         RBH_BountySpyCnt = RBH_BountySpyCnt + 1
         table.insert(RBH_BountySpyNames,{name=RBH_IntelList[i].name})
      end
   end   
   RBH_LargessMessage("Searching for "..RBH_BountySpyCnt.." bounty targets...")  
end

function RBH_SendWhoQuery(name)
   SetWhoToUI(1)
   FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
   SendWho(name)
end

function RBH_IntelReport()
    local i, j, msg
    for i = 1,#RBH_IntelList do
        if RBH_IntelList[i].intelage == nil or RBH_IntelList[i].intelage == "" then
            RBH_IntelList[i].intelage = 0            
        else
            for j = 1,#RBH_HitList do         
                if RBH_HitList[j].intelage == nil or RBH_HitList[j].intelage == "" then
                    RBH_HitList[j].intelage = 0
                end
                if (RBH_IntelList[i].name == RBH_HitList[j].name) and (RBH_IntelList[i].intelage > RBH_HitList[j].intelage) then
                    RBH_HitList[j].zone = RBH_IntelList[i].zone
                    RBH_HitList[j].level = RBH_IntelList[i].level
                    RBH_HitList[j].race = RBH_IntelList[i].race
                    RBH_HitList[j].class = RBH_IntelList[i].class  
                    RBH_HitList[j].realm = RBH_IntelList[i].realm
                    RBH_HitList[j].intelage = RBH_IntelList[i].intelage
                    msg = RBH_BountyToString(j)
                    RBH_SendAddonMessageToNetwork("NORMAL","RBH_HL_UPDATE",msg,"GUILD");
                end       
            end
        end
    end
    RBH_LargessMessage("Guild agents have reported back intelligence data.")
    RBH_IntelList = nil
    RBH_FilterHitList()
    RBH_HitListUpdate()
end